﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using System.IO;

namespace PDFWebViewer
{
    public partial class Index : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        protected void btn_upload_Click(object sender, EventArgs e)
        {
            if (fp_upload.HasFile)//判断文件上传控件是否包含文件
            {
                try
                {
                    string filePath = fp_upload.FileName;//上载的文件的名称
                    //上载的文件的名称-去掉文件格式
                    string fileName = fp_upload.FileName.Substring(0, filePath.LastIndexOf("."));
                    string fileExtention = filePath.Substring(filePath.LastIndexOf(".") + 1);//上传文件的文件格式
                    string swfToolPath = ConfigurationManager.AppSettings["swfToolPath"];//工具文件的绝对地址
                    swfToolPath = HttpContext.Current.Server.MapPath(swfToolPath);//工具文件的物理地址
                    string uploadPath = ConfigurationManager.AppSettings["uploadPath"]; //上传文件夹的绝对地址
                    uploadPath = HttpContext.Current.Server.MapPath(uploadPath);//上传文件夹地址的物理地址
                    string onlyData = DateTime.Now.ToString("yyyyMMddHHmmssfff");//当前时间格式化字符串
                    string uploadFlieName = onlyData + "." + fileExtention; //保存的上传文件名
                    string uploadPDFName = onlyData + ".pdf";//保存的pdf文件名
                    string uploadWSFName = onlyData + ".swf";//保存的swf文件名
                    string uploadFliePath = uploadPath + uploadFlieName;
                    string uploadPDFPath = uploadPath + uploadPDFName;
                    string uploadWSFPath = uploadPath + uploadWSFName;


                    #region 文件上传
                    if (!Directory.Exists(uploadPath))
                    {
                        Directory.CreateDirectory(uploadPath);
                    }
                    fp_upload.SaveAs(uploadFliePath);//保存文件到服务器上
                    #endregion


                    bool bl = Convert(uploadFliePath, fileExtention, uploadPDFPath);

                    if (bl)
                    {
                        #region PDF文件转换为SWF文件
                        /*-t: 源文件路径，即待转换的pdf文件路径。
                     * -s: 设置参数,这里我们设置为 flashversion=9 ，即可以转换为9 的版本
                     * -o: 输出文件的路径
                     * */
                        //文件路径包含到""内防止要转换的过程中，文件夹名字带有空格，导致失败
                        string cmdStr = "  -t  \"" + uploadPDFPath + "\" -s flashversion=9 -o \"" + uploadWSFPath + "\"";
                        bool iss = PDFWebViewer.BaseClass.YcTools.PdfToSwf(swfToolPath, cmdStr);//执行文件转换
                        #endregion

                        if (iss)//转换成功则跳到文档预览页面
                        {
                            string path = ConfigurationManager.AppSettings["uploadPath"].Substring(2) + uploadWSFName;
                            Response.Redirect("PDFViewer.aspx?path=" + path, true);
                        }
                        else { ShowBad(); }
                    }
                    else { ShowBad(); }

                }
                catch
                {
                    ShowBad();
                }
            }
            else
            {
                Page.ClientScript.RegisterStartupScript(this.GetType(), "", "<script>alert('请选择需要查看的PDF文档文件！')</script>");
            }
        }
        private bool Convert(string uploadFliePath, string fileExtention, string uploadPDFPath)
        {
            PDFWebViewer.BaseClass.ConvertToPDF c = new PDFWebViewer.BaseClass.ConvertToPDF();
            bool bl = false;
            switch (fileExtention.ToUpper())
            {
                case "DOC":
                case "DOCX":
                    bl = c.DOC2PDF(uploadFliePath, uploadPDFPath);
                    break;
                case "XLS":
                case "XLSX":
                    bl = c.XLS2PDF(uploadFliePath, uploadPDFPath);
                    break;
                case "PPT":
                case "PPTX":
                    bl = c.PPT2PDF(uploadFliePath, uploadPDFPath);
                    break;
                case "PDF":
                    bl = true;
                    break;
                default:
                    bl = false;
                    break;
            }
            return bl;
        }

        private void ShowBad()
        {
            Page.ClientScript.RegisterStartupScript(this.GetType(), "", "<script>alert('类型转换失败！')</script>");
        }
    }
}